/* a Q&D Hack by Frank M. Siegert, no guarantee, no mercy ;-) */

#import "QubixView.h"
#import "qubic.h"

/* external reference to qubic.m, not nice but functional */
extern char *remark;

@implementation QubixView

- flipSides:sender
{
	flipsides();
	return self;
}

- helpMe:sender
{
	help();
    	return self;
}

- newGame:sender
{
	newgame();
    	return self;
}

- undoMove:sender
{
	undo();
    	return self;
}

- updateSliders:sender
{
    updateSliderPos([Horizonal doubleValue], [Vertical doubleValue]);
    [self display];
    return self;
}

- setTitleDelayed:sender
{
	if (remark) [[self window] setTitle:remark];
		else [[self window] setTitle:"Qubic"];
	return self;
}

- drawSelf:(NXRect *)r: (int) count
{
	if (!inited) {
		setupGFX(self);
		inited++;
	}
	drawfrom(0,FALSE);
	/* do not draw title everytime, only once */
	[self perform:@selector(setTitleDelayed:) with:NULL afterDelay:200 cancelPrevious:YES];
	return self;
}

- mouseDown:(NXEvent *)e
{
    NXPoint p;
    int     retv;
    int     oldMask = [window addToEventMask:NX_LMOUSEDRAGGEDMASK];

    p = e->location;
    [self convertPoint: &p fromView: nil];
    while(1) {
        retv= setAPiece(&p,0);
	NXPing();    
	e = [NXApp getNextEvent:(NX_LMOUSEUPMASK | NX_LMOUSEDRAGGEDMASK)];
	if (e->type == NX_LMOUSEUP)
	    break;
	p = e->location;
	[self convertPoint: &p fromView: nil];
    }
    /* 3 == a new piece was established, so set it */
    if (retv == 3) {
	setAPiece(&p,1);
    } else {
	[self display];
	DPSFlush();
    }
    [window setEventMask:oldMask];
    return self;
}

- (BOOL) acceptsFirstResponder
{
    return YES;
}

@end
